; DoubleSnapFromPoint v.2005-04-04
; makes 2 different snaps of top-level window or control from point: 
; 1) output bitmap file,
; 2) output popup window-'copy'.
; Plus output rgn-file if snapped window has region (GetRegionData/ExtCreateRegion).
; Plus drag'n'drop bmp- and rgn- files to window-'copy'.
;
; Make shortcut with hotkey assignment to DoubleSnapFromPoint.exe.
; If run with (Ins key + <hotkey>) => top-level parent window from point.
;
; Used source - http://spiff.tripnet.se/~iczelion/files/CapScreen.txt,
; but it doesn't work with WS_EX_LAYERED-windows (on WinOS>=Win2k). 
; So - added CAPTUREBLT plus something else for alpha channel (draft yet). 
;
; http://www.geocities.com/xmemor/2lz/doublesnapfrompoint.zip
; http://www.geocities.com/xmemor/2lz/tinyasm.html

.386
.model flat,stdcall
option casemap:none

include 		\masm32\include\windows.inc
include 		\masm32\include\user32.inc
include 		\masm32\include\kernel32.inc
include 		\masm32\include\gdi32.inc
include 		\masm32\include\shell32.inc
includelib 	\masm32\lib\user32.lib
includelib 	\masm32\lib\kernel32.lib
includelib 	\masm32\lib\gdi32.lib
includelib 	\masm32\lib\shell32.lib

;WinFromPoint	proto
;;EnChProc			proto :DWORD,:DWORD
;;WinFromPoint	proto :DWORD
;SaveRegion		proto :DWORD,:DWORD
;LoadRegion		proto :DWORD,:DWORD
;LoadBitmapBG	proto :DWORD,:DWORD:DWORD
;CapRect			proto :DWORD,:DWORD,:DWORD
;WndProc			proto :DWORD,:DWORD,:DWORD,:DWORD
;WinMain			proto :DWORD,:DWORD,:DWORD,:DWORD

.const
WS_EX_LAYERED	equ 80000h
LWA_ALPHA 		equ 2h
LWA_COLORKEY 	equ 1h
ULW_COLORKEY	equ 1h
ULW_OPAQUE		equ 4h
ULW_ALPHA			equ 2h
CAPTUREBLT		equ 40000000h
INVALID_FILE_SIZE	equ 0FFFFFFFFh

.data
about 				db "DoubleSnapFromPoint by kero <geocities.com/memor> v.2005-04-04",0
filenamefrmt	db "%s_%lu.bmp",0
wintextfrmt		db "%8.8lx_%8.8lx",0
;szNoDC        db "Couldn''t create device context.",0
;szNoDC        db "Couldn''t get device context.",0
szNoMemDC     db "Couldn''t create compatible device context.",0
szNoBMP       db "Couldn''t create compatible bitmap.",0
szNoObj       db "Couldn''t select bitmap.",0
szNoCopy      db "Couldn''t copy bitmap.",0
szNoFile      db "Couldn''t write file to disk.",0
;szDone        db "Bitmap captured to disk file.",0
dllname				db "user32",0
glwa					db "GetLayeredWindowAttributes",0						; Win OS >= Win XP
err						db "ERROR",0
rgnmask					db "LastMask.bmp",0

.data?
hbrush				HBRUSH ?
;params				dd 4 dup(?)			; <pt.x,pt.y,hwnd,minway>
rect					RECT <?>

.code

;####################################################################################################

;WinBorderPtDist proc uses ebx hWnd:HWND,lppoint:DWORD
;	local rt:RECT
;
;	mov ebx,lppoint
;	invoke GetWindowRect,hWnd,addr rt
;
;	mov eax,dword ptr [ebx]
;	sub eax,rt.left
;	mov ecx,rt.right
;	sub ecx,dword ptr [ebx]
;	cmp eax,ecx
;	jle @f
;	mov eax,ecx
;@@:
;	mov ecx,dword ptr [ebx+4]
;	sub ecx,rt.top
;	cmp eax,ecx
;	jle @f
;	mov eax,ecx
;@@:
;	mov ecx,rt.bottom
;	sub ecx,dword ptr [ebx+4]
;	cmp eax,ecx
;	jle @f
;	mov eax,ecx
;@@:
;	ret
;WinBorderPtDist endp


WinFromPoint proc
	local pt:POINT
	local hwnd:HWND

	invoke GetCursorPos,addr pt

	;invoke WindowFromPoint,pt.x,pt.y

	invoke GetDesktopWindow
@@:
	mov hwnd,eax
	invoke ScreenToClient,hwnd,addr pt
	invoke ChildWindowFromPointEx,hwnd,pt.x,pt.y,CWP_SKIPINVISIBLE or CWP_SKIPTRANSPARENT
	.if eax!=0 && eax!=hwnd
		push eax
		invoke ClientToScreen,hwnd,addr pt
		pop eax
		jmp @b
	.endif
	mov eax,hwnd
	ret
WinFromPoint endp


;####################################################################################################

;EnChProc proc uses ebx edi hWnd:HWND,param:DWORD
;	local rt:RECT
;	local hrgn:HRGN
;
;	mov edi,param
;	invoke CreateRectRgn,0,0,0,0
;	mov	hrgn,eax
;	invoke IsWindowVisible,hWnd
;	test eax,eax
;	jz @out
;	invoke GetWindowRect,hWnd,addr rt
;	invoke GetWindowRgn,hWnd,hrgn
;	test eax,eax
;	jz @f
;	mov eax,dword ptr [edi]
;	sub eax,rt.left
;	mov ecx,dword ptr [edi+4]
;	sub ecx,rt.top
;	invoke PtInRegion,hrgn,eax,ecx
;	test eax,eax
;	jz @out
;@@:																; is point (edge of cursor) within rectangle ?
;	mov	eax,dword ptr [edi]
;	sub	eax,rt.left
;	jl	@out
;	mov	ecx,rt.right
;	sub	ecx,dword ptr [edi]
;	jl	@out
;	mov	edx,dword ptr [edi+4]
;	sub	edx,rt.top
;	jl	@out
;	mov	ebx,rt.bottom
;	sub	ebx,dword ptr [edi+4]
;	jl	@out
;	cmp	eax,ecx											; hwnd from point (search immediate rectangle)
;	jle	@f
;	mov	eax,ecx
;@@:
;	cmp	eax,edx
;	jle	@f
;	mov	eax,edx
;@@: 
;	cmp	eax,ebx
;	jle	@f
;	mov	eax,ebx
;@@:
;	cmp	eax,dword ptr [edi+12]
;	jge	@out
;	mov	dword ptr [edi+12],eax
;	mov	eax,hWnd
;	mov	dword ptr [edi+8],eax
;@out:
;	invoke DeleteObject,hrgn
;	xor	eax,eax
;	inc	eax
;	ret
;EnChProc endp

;####################################################################################################

;;WindowUnderCursor proc uses edi param:DWORD
;WinFromPoint proc uses edi param:DWORD
;	mov edi,param
;	xor eax,eax
;	mov dword ptr [edi+8],eax
;	mov dword ptr [edi+12],7FFFFFFFh
;	invoke	GetCursorPos,edi
;	invoke	GetDesktopWindow
;	invoke	EnumChildWindows,eax,addr EnChProc,edi
;	test eax,eax
;	jz @f
;	mov eax,dword ptr [edi+8]
;@@:
;	ret
;WinFromPoint endp
;;WindowUnderCursor endp

;####################################################################################################

SaveRegion proc hrgn:HRGN,lpfilename:LPSTR
	local dwcount:DWORD
	local lprgndata:DWORD		;RGNDATA
	local hfile:HFILE

	invoke GetRegionData,hrgn,0,0
	test eax,eax
	jz @err
	mov dwcount,eax
	invoke VirtualAlloc,0,eax,MEM_COMMIT,PAGE_READWRITE
	mov lprgndata,eax
	invoke GetRegionData,hrgn,dwcount,eax
	invoke CreateFile,lpfilename,GENERIC_READ or GENERIC_WRITE,FILE_SHARE_READ,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
	cmp	eax,INVALID_HANDLE_VALUE
	jz	@err
	mov	hfile,eax
	invoke WriteFile,hfile,lprgndata,dwcount,addr dwcount,0
	invoke CloseHandle,hfile
	invoke	VirtualFree,lprgndata,0,MEM_RELEASE
	ret
@err:
	invoke MessageBox,0,offset err,0,0
	ret
SaveRegion endp

;####################################################################################################

LoadRegion proc lpxform:DWORD,lpfilename:LPSTR
	local hfile:HFILE
	local dwcount:DWORD
	local lprgndata:DWORD		;RGNDATA
	local hrgn:DWORD

	xor eax,eax
	mov hrgn,eax
	invoke CreateFile,lpfilename,GENERIC_READ,FILE_SHARE_READ,0,OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
	cmp	eax,INVALID_HANDLE_VALUE
	jz @01
	mov	hfile,eax
	invoke GetFileSize,eax,0
	cmp eax,INVALID_FILE_SIZE
	jz @02
	mov	dwcount,eax
	invoke VirtualAlloc,0,eax,MEM_COMMIT,PAGE_READWRITE
	test eax,eax
	jz @02
	mov lprgndata,eax
	invoke ReadFile,hfile,lprgndata,dwcount,addr dwcount,0
	test eax,eax
	jz @03
	invoke ExtCreateRegion,lpxform,dwcount,lprgndata
	mov hrgn,eax
@03:
	invoke VirtualFree,lprgndata,0,MEM_RELEASE
@02:
	invoke CloseHandle,hfile
@01:
	mov eax,hrgn
	ret
LoadRegion endp

;####################################################################################################

LoadBitmapBG proc uses edi esi hWnd:HWND,lpFileName:LPSTR,SizeFlag:BOOL
	local hbmp:HBITMAP
	local btmp:BITMAP
	local hbrsh:DWORD
	local rt:RECT

	xor eax,eax
	mov hbrsh,eax
	mov edi,eax
	mov esi,eax
	mov eax,SizeFlag
	test eax,eax
	jz @f
	invoke GetWindowRect,hWnd,addr rt
	mov edi,rt.right
	sub edi,rt.left
	mov esi,rt.bottom
	sub esi,rt.top
@@:
	invoke LoadImage,0,lpFileName,IMAGE_BITMAP,edi,esi,LR_LOADFROMFILE
	test eax,eax
	jz @1
	mov hbmp,eax
	invoke CreatePatternBrush,eax
	test eax,eax
	jz @f
	mov hbrsh,eax
	invoke SetClassLong,hWnd,GCL_HBRBACKGROUND,eax
	invoke GetObject,hbmp,sizeof btmp,addr btmp
	invoke SetWindowPos,hWnd,0,0,0,btmp.bmWidth,btmp.bmHeight,SWP_NOMOVE or SWP_NOZORDER
@@:
	invoke DeleteObject,hbmp
@1:
	mov eax,hbrsh
	ret
LoadBitmapBG endp

;####################################################################################################

CapRect proc uses ebx edi hdc:HDC,lpRect:DWORD,lpFileName:DWORD

  local dwLeft						:DWORD
  local dwTop							:DWORD
  local dwWidth						:DWORD
  local dwHeight					:DWORD
  local dwBPP							:DWORD
  local dwNumColors				:DWORD
  local memdc							:HDC
  local bitmapinfoheader	:BITMAPINFOHEADER
  local bmpinfo						:BITMAPINFO
  local pBits							:DWORD
  local hBitmap						:HBITMAP
  local colors[256]				:RGBQUAD
  local bitmapfileheader	:BITMAPFILEHEADER
  local ColorSize					:DWORD
  local hFile							:HANDLE
  local dwBytes						:DWORD
	local hbmp							:HBITMAP

	mov edx,lpRect
	mov eax,dword ptr [edx]
	mov dwLeft,eax
	mov ecx,dword ptr [edx+4]
	mov dwTop,ecx
	mov ebx,dword ptr [edx+8]
	sub ebx,eax
	mov dwWidth,ebx
	mov ebx,dword ptr [edx+12]
	sub ebx,ecx
	mov dwHeight,ebx
	xor ebx,ebx

  invoke GetDeviceCaps,hdc,BITSPIXEL
  mov dwBPP,eax
  mov dwNumColors,ebx
	cmp eax,8
	ja @f
	invoke GetDeviceCaps,hdc,NUMCOLORS
	mov dwNumColors,eax
@@:
  invoke CreateCompatibleDC,hdc
	mov edi,offset szNoMemDC
	test eax,eax
	jz ExitFunc
  mov memdc,eax

  mov bmpinfo.bmiHeader.biSize,sizeof BITMAPINFOHEADER
  mov eax,dwWidth
  mov bmpinfo.bmiHeader.biWidth,eax
  mov eax,dwHeight
  mov bmpinfo.bmiHeader.biHeight,eax
  mov bmpinfo.bmiHeader.biPlanes,1
  mov ax,word ptr [dwBPP]
  mov bmpinfo.bmiHeader.biBitCount,ax
  mov bmpinfo.bmiHeader.biCompression,BI_RGB
  mov bmpinfo.bmiHeader.biSizeImage,ebx
  mov bmpinfo.bmiHeader.biXPelsPerMeter,ebx
  mov bmpinfo.bmiHeader.biYPelsPerMeter,ebx
  mov eax,dwNumColors
  mov bmpinfo.bmiHeader.biClrUsed,eax
  mov bmpinfo.bmiHeader.biClrImportant,eax
 
  invoke CreateDIBSection,hdc,addr bmpinfo,DIB_PAL_COLORS,addr pBits,ebx,ebx
	mov edi,offset szNoBMP
	test eax,eax
	jz ExitFunc3
  mov hBitmap,eax
  invoke SelectObject, memdc, hBitmap
	mov edi,offset szNoObj
  .if (eax==NULL) || (eax==GDI_ERROR)
      jmp ExitFunc3
  .endif
;;test eax,eax
;;jz @f
;;cmp eax,GDI_ERROR
;;@@:
;;jz ExitFunc3

 invoke BitBlt,memdc,ebx,ebx,dwWidth,dwHeight,hdc,dwLeft,dwTop,SRCCOPY or CAPTUREBLT   ; instead of just (SRCCOPY
;	invoke StretchBlt,memdc,ebx,ebx,dwWidth,dwHeight,hdc,dwLeft,dwTop,dwWidth,dwHeight,SRCCOPY or CAPTUREBLT

	mov edi,offset szNoCopy
	test eax,eax
	jz ExitFunc3

  mov eax,dwNumColors
	test eax,eax
	jz @f
	invoke GetDIBColorTable,memdc,ebx,dwNumColors,addr colors
	mov dwNumColors,eax
@@:
  mov bitmapfileheader.bfType,4D42h
  mov eax,dwNumColors
  xor edx,edx
  mov ecx,sizeof RGBQUAD
  mul ecx
  mov ColorSize,eax
  mov eax,dwWidth
  xor edx,edx
  mov ecx,dwHeight
  mul ecx
  xor edx,edx
  mov ecx,dwBPP
  mul ecx
  shr eax,3
  add eax,ColorSize
  add eax,sizeof BITMAPFILEHEADER
  add eax,sizeof BITMAPINFOHEADER
  mov bitmapfileheader.bfSize,eax
  mov bitmapfileheader.bfReserved1,bx
  mov bitmapfileheader.bfReserved2,bx
  mov eax,ColorSize
  add eax,sizeof BITMAPFILEHEADER
  add eax,sizeof BITMAPINFOHEADER
  mov bitmapfileheader.bfOffBits,eax
  mov bitmapinfoheader.biSize,sizeof BITMAPINFOHEADER
  mov eax,dwWidth
  mov bitmapinfoheader.biWidth,eax
  mov eax,dwHeight
  mov bitmapinfoheader.biHeight,eax
  mov bitmapinfoheader.biPlanes,1
  mov ax,word ptr [dwBPP]
  mov bitmapinfoheader.biBitCount,ax
  mov bitmapinfoheader.biCompression,BI_RGB
  mov bitmapinfoheader.biSizeImage,ebx
  mov bitmapinfoheader.biXPelsPerMeter,ebx
  mov bitmapinfoheader.biYPelsPerMeter,ebx
  mov eax,dwNumColors
  mov bitmapinfoheader.biClrUsed,eax
  mov bitmapinfoheader.biClrImportant,ebx

  invoke CreateFile,lpFileName,GENERIC_WRITE,ebx,ebx,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,ebx
	mov edi,offset szNoFile
	cmp eax,INVALID_HANDLE_VALUE
	jz ExitFunc4
  mov hFile,eax

  invoke WriteFile,hFile,addr bitmapfileheader,sizeof BITMAPFILEHEADER,addr dwBytes,ebx
  invoke WriteFile,hFile,addr bitmapinfoheader,sizeof BITMAPINFOHEADER,addr dwBytes,ebx
  mov eax,dwNumColors
	test eax,eax
	jz @f
	invoke WriteFile,hFile,addr colors,ColorSize,addr dwBytes,ebx
@@:
  mov eax,dwWidth
  xor edx,edx
  mov ecx,dwHeight
  mul ecx
  xor edx,edx
  mov ecx,dwBPP
  mul ecx
  shr eax,3
  mov ColorSize,eax

  invoke WriteFile,hFile,pBits,ColorSize,addr dwBytes,ebx
  invoke CloseHandle,hFile
  xor edi,edi
ExitFunc4:
  invoke DeleteObject,hBitmap
ExitFunc3:
  invoke DeleteDC,memdc
ExitFunc:
	test edi,edi
	jz @f
  invoke MessageBox, ebx, edi, ebx, ebx
@@:
  ret
CapRect endp

;####################################################################################################

RgnDataShow proc uses ebx edi esi hrgn:HRGN,hWnd:HWND
	local dwcount:DWORD
;	local lprgndata:DWORD		;RGNDATA
	local buf[1024]:BYTE
	local hdc:HDC
	local hbr_b:HBRUSH
	local hbr_w:HBRUSH
	local hbr_g:HBRUSH
	local pretop:DWORD
	local prehbr:DWORD

	invoke GetRegionData,hrgn,0,0
	test eax,eax
	jz @err
	mov dwcount,eax
	invoke VirtualAlloc,0,eax,MEM_COMMIT,PAGE_READWRITE
	test eax,eax
	jz @err
	mov edi,eax
	invoke GetRegionData,hrgn,dwcount,eax
	test eax,eax
	jz @err
	invoke GetWindowDC,hWnd
	mov hdc,eax
	invoke	GetStockObject,BLACK_BRUSH
	mov	hbr_b,eax
	invoke	GetStockObject,WHITE_BRUSH
	mov	hbr_w,eax
	invoke	GetStockObject,LTGRAY_BRUSH
	mov	hbr_g,eax
	mov ebx,dword ptr [edi+8]		; number of rectangles
	mov esi,edi
	add esi,16									; bounding rectangle for the region
	xor eax,eax
	mov dword ptr [esi],eax
	mov dword ptr [esi+4],eax
	invoke FillRect,hdc,esi,hbr_w
	add esi,16
	xor eax,eax
	dec eax
	mov pretop,eax
	mov eax,hbr_g
	mov prehbr,eax
	.while ebx!=0
		mov eax,dword ptr [esi+4]
		cmp eax,pretop
		jz @f
		mov pretop,eax
		mov eax,prehbr
		.if eax==hbr_g
			mov eax,hbr_b
		.else
			mov eax,hbr_g
		.endif
		mov prehbr,eax
@@:
		invoke FillRect,hdc,esi,prehbr
		add esi,16
		dec ebx
	.endw
	mov ecx,edi
	add ecx,16
	invoke CapRect,hdc,ecx,offset rgnmask
	invoke ReleaseDC,hWnd,hdc
	invoke	VirtualFree,edi,0,MEM_RELEASE
	ret
@err:
	invoke MessageBox,0,offset err,0,0
	ret
RgnDataShow endp

;####################################################################################################

WndProc proc uses ebx edi hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	local dropfile[MAX_PATH+1]:BYTE
	local hdc:HDC
	local pt:POINT
	local rt:RECT
	local hwin:HWND
	local hrgn:HRGN


	mov eax,uMsg
	.if eax==WM_DESTROY || eax==WM_RBUTTONUP
		invoke DeleteObject,hbrush
		invoke PostQuitMessage,0

;	.elseif eax==WM_CREATE

	.elseif eax==WM_LBUTTONDOWN
;		invoke ReleaseCapture
    invoke SendMessage,hWnd,WM_NCLBUTTONDOWN,HTCAPTION,lParam

	.elseif eax==WM_LBUTTONDBLCLK
		invoke GetKeyState,VK_CONTROL
		and eax,8000h
		.if eax!=0
			invoke SetWindowRgn,hWnd,0,1
		.else
			invoke GetKeyState,VK_SHIFT
			and eax,8000h
			.if eax!=0
				invoke GetWindowLong,hWnd,GWL_EXSTYLE
				and eax,not WS_EX_LAYERED
				push eax
				invoke SetWindowLong,hWnd,GWL_EXSTYLE,eax
				invoke GetWindowDC,hWnd
				mov hdc,eax
				invoke GetCursorPos,addr pt
				invoke GetWindowRect,hWnd,addr rt
				mov eax,pt.x
				sub eax,rt.left
				mov ecx,pt.y
				sub ecx,rt.top
				invoke GetPixel,hdc,eax,ecx
				and	eax,0ffffffh
				pop ecx
				push eax
				or ecx,WS_EX_LAYERED
				invoke SetWindowLong,hWnd,GWL_EXSTYLE,ecx
				pop eax
				invoke SetLayeredWindowAttributes,hWnd,eax,128,LWA_COLORKEY
				invoke ReleaseDC,hWnd,hdc
			.else
				invoke GetKeyState,VK_MENU
				and eax,8000h
				.if eax!=0
					invoke GetWindowLong,hWnd,GWL_EXSTYLE
					and eax,not WS_EX_LAYERED
					invoke SetWindowLong,hWnd,GWL_EXSTYLE,eax
				.else
					invoke IsZoomed,hWnd
					.if eax==0
    				invoke ShowWindow,hWnd,SW_SHOWMAXIMIZED
					.else
						invoke ShowWindow,hWnd,SW_RESTORE
					.endif
				.endif
			.endif
		.endif

	.elseif	eax==WM_KEYDOWN && wParam==VK_F8
;		invoke GetCursorPos,addr pt
;		invoke WindowFromPoint,pt.x,pt.y
;		invoke WinFromPoint,addr params

		invoke WinFromPoint
		mov hwin,eax

		invoke CreateRectRgn,0,0,0,0
		mov hrgn,eax
		invoke GetWindowRgn,hWnd,eax
		test eax,eax
		jz @f
		mov eax,hrgn
@@:
		invoke SetWindowRgn,hwin,eax,1
		invoke DeleteObject,hrgn

	.elseif	eax==WM_KEYDOWN && wParam==VK_F11
		invoke GetWindowRect,hWnd,addr rt
		invoke GetDC,0
		mov hdc,eax
		invoke InvertRect,hdc,addr rt
		invoke ReleaseDC,0,hdc

;	.elseif	eax==WM_SIZE

	.elseif	eax==WM_DROPFILES
		invoke DragQueryFile,wParam,0,addr dropfile,MAX_PATH
		invoke DragFinish,wParam
		invoke GetKeyState,VK_F2
		and eax,8000h
		invoke LoadBitmapBG,hWnd,addr dropfile,eax
		test eax,eax
		jz @@@
		push eax
		invoke DeleteObject,hbrush
		pop hbrush
		jmp @f
@@@:
		invoke LoadRegion,0,addr dropfile
		push eax
		invoke SetWindowRgn,hWnd,eax,1
		pop eax
		test eax,eax
		jz @f
		invoke DeleteObject,eax
@@:
		invoke ShowWindow,hWnd,SW_HIDE
		invoke ShowWindow,hWnd,SW_NORMAL
	.else
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam		
		ret
	.endif
	xor eax,eax
	ret
WndProc endp

;####################################################################################################

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,lpszArgs:LPSTR,nWinMode:DWORD

	local wc:WNDCLASSEX
	local msg:MSG
	local hwnd:HWND
	local hwin:HWND
	local rt:RECT
	local pt:POINT
	local hrgn:HRGN
	local winclass[MAX_PATH+1]:BYTE
	local wintext[MAX_PATH+1]:BYTE
	local filename[MAX_PATH+1]:BYTE
	local len:DWORD
	local hbmp:HBITMAP
	local clref:DWORD
	local alph:BYTE
	local flg:DWORD
	local buf[128]:BYTE
	local lrd:DWORD
	local hdc:HDC

	mov wc.cbSize,sizeof WNDCLASSEX
	mov eax,hInst
	mov wc.hInstance,eax
	mov wc.lpfnWndProc,offset WndProc
	mov wc.style,CS_HREDRAW or CS_VREDRAW or CS_DBLCLKS ;or CS_BYTEALIGNWINDOW
	invoke LoadIcon,0,IDI_APPLICATION
	mov wc.hIcon, eax
	invoke LoadIcon,0,IDI_WINLOGO
	mov wc.hIconSm,eax
	invoke LoadCursor,0,IDC_ARROW
	mov wc.hCursor,eax
	mov wc.lpszMenuName,0
	mov wc.cbClsExtra,0
	mov wc.cbWndExtra,0
	mov wc.hbrBackground,COLOR_WINDOW+1

;	invoke GetCursorPos,addr pt
;	invoke WindowFromPoint,pt.x,pt.y
;	invoke WinFromPoint,addr params

	invoke WinFromPoint
	mov hwin,eax

	invoke GetKeyState,VK_INSERT
	test eax,8000h
	jz @f
@1:
	invoke GetWindowLong,hwin,GWL_STYLE
	test eax,WS_CHILD
	jz @f
	invoke GetWindowLong,hwin,GWL_HWNDPARENT
	mov hwin,eax
	jmp @1
@@:
	invoke GetClassName,hwin,addr winclass,MAX_PATH
	mov len,eax
	push eax
	invoke GetTickCount
	push eax
	invoke wsprintf,addr filename,addr filenamefrmt,addr winclass,eax
	push eax
	xor ecx,ecx
	lea edx,filename
	.while ecx<len
		mov al,byte ptr [edx+ecx]
		.if al=='\' || al=='/' || al==':' || al=='*' || al=='?' || al=='"' || al=='<' || al=='>' || al=='|'
			mov byte ptr [edx+ecx],''
		.endif
		inc ecx
	.endw
	pop eax
	mov len,eax
	pop eax
	invoke wsprintf,addr wintext,addr wintextfrmt,hwin,eax
	pop ecx
	lea eax,winclass
	mov dword ptr [eax+ecx],[0]['_']
	mov wc.lpszClassName,eax

	invoke RegisterClassEx,addr wc

	invoke GetWindowLong,hwin,GWL_EXSTYLE
	and eax,WS_EX_LAYERED
	mov lrd,eax
	or eax, WS_EX_TOOLWINDOW or WS_EX_ACCEPTFILES or WS_EX_TOPMOST
	push eax
	invoke GetWindowRect,hwin,addr rt
	mov eax,rt.right
	sub eax,rt.left
	mov ecx,rt.bottom
	sub ecx,rt.top
	pop edx
	invoke CreateWindowEx,edx,addr winclass,addr wintext,WS_POPUP,rt.left,rt.top,eax,ecx,0,0,hInst,0
;	invoke CreateWindowEx,edx,addr winclass,addr wintext,WS_POPUP or WS_THICKFRAME,rt.left,rt.top,eax,ecx,0,0,hInst,0
	mov hwnd,eax

	mov eax,lrd
	test eax,eax
	jz @skp

; Since masm32 v.8 has user32.lib without GetLayeredWindowAttributes function, so:

	lea eax,flg
	push eax
	lea eax,alph
	push eax
	lea eax,clref
	push eax
	push hwin
	invoke GetModuleHandle,offset dllname
	invoke GetProcAddress,eax,offset glwa
	call eax

	mov cl,alph
	and ecx,0ffh
	.if eax==0
		invoke SetLayeredWindowAttributes,hwnd,clref,ecx,LWA_ALPHA or LWA_COLORKEY
		lea eax,wintext
		mov dword ptr[eax+17],[0]['><_']
		invoke SendMessage,hwnd,WM_SETTEXT,0,eax
		invoke SetWindowPos,hwnd,0,0,0,0,0,SWP_NOSIZE or SWP_NOZORDER
	.else
		invoke SetLayeredWindowAttributes,hwnd,clref,ecx,flg
	.endif
;;invoke UpdateLayeredWindow,hwnd,0,0,addr size,hdc,addr pt,clref,0,ulw_
@skp:
;	invoke GetWindowDC,0
	invoke GetDC,0
	mov hdc,eax
	invoke GetWindowRect,hwin,addr rect
	invoke CapRect,hdc,addr rect,addr filename
	invoke LoadBitmapBG,hwnd,addr filename,0
	test eax,eax
	jnz @f
	ret
@@:
	mov hbrush,eax
	invoke CreateRectRgn,0,0,0,0
	mov	hrgn,eax
	invoke GetWindowRgn,hwin,hrgn
	test eax,eax
	jz @f
	mov eax,len
	sub eax,3
	mov dword ptr [filename + eax],[0]['ngr']
	invoke SaveRegion,hrgn,addr filename
	
;	invoke RgnDataShow,hrgn,hwin
	invoke RgnDataShow,hrgn,0

	invoke SetWindowRgn,hwnd,hrgn,1
@@:
	invoke DeleteObject,hrgn
	mov eax,hbmp
	test eax,eax
	jz @f
	invoke DeleteObject,eax
@@:
	invoke ShowWindow,hwnd,nWinMode
	invoke UpdateWindow,hwnd
	.while TRUE
		invoke GetMessage,addr msg,0,0,0
		.break .if (!eax)
		invoke TranslateMessage,addr msg
		invoke DispatchMessage,addr msg
	.endw
	mov eax,msg.wParam
	ret
WinMain endp

;####################################################################################################

start:
	xor eax,eax
	mov hbrush,eax
	invoke GetModuleHandle,eax
	invoke WinMain,eax,0,0,SW_SHOWDEFAULT
	invoke ExitProcess,eax
end start

;####################################################################################################
